/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.ergebnis.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.entity.Gewaehlt;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class GewaehltExtendedDAO extends AbstractGewaehltDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: CountErgebnisNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT COUNT(o) FROM Gewaehlt o WHERE o.ergebnis=?1<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByCountErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gewaehlt.findByCountErgebnis" ,  ergebnis  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByCountErgebnis(): Miss");
        }

        cache.put(key, super.findByCountErgebnis( ergebnis  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByCountErgebnis(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByCountErgebnis( ergebnis  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
